#
# spec file for package hyper-v
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define with_kmp 1
%if %{with_kmp}
%define with_drivers_in_kmp 1
%endif
%define hv_kvp_daemon hv_kvp_daemon
%define HVMODULES hv_mouse hv_netvsc hv_storvsc hv_timesource hv_utils hv_vmbus

Name:           microsoft-hyper-v
%if %{with_kmp}
BuildRequires:  kernel-default-devel
BuildRequires:  kernel-trace-devel
BuildRequires:  module-init-tools

%ifarch %ix86
BuildRequires:  kernel-pae-devel
%endif
%endif
ExclusiveArch:  %ix86 x86_64
PreReq:         %insserv_prereq
Group:          System/Kernel
AutoReqProv:    on
Obsoletes:      hyper-v
Provides:       hyper-v
Requires:	microsoft-hyper-v-kmp
Summary:        Microsoft Hyper-V tools
Url:            http://www.kernel.org
Version:        3
Release:        25.1
Source:         Module.supported
Source1:        hyperv_pvdrivers.conf
Source2:        kmp_filelist
Source3:        hyper-v.supplements.txt
Source4:        hyper-v.dummy_ko.c
Source10:       hv_kvp_daemon.c
Source11:       hyper-v.init.sh
Source42:       hv-oct-8a.tar
Source5:	updateinitrd.pl
Source6:	update_UUID_in_grub.pl
Source7:	update_UUID_in_bootloader.pl
Source8:	updatefstab.sh
Patch42:        hv-oct-8a.patch
Patch43:	pldp-warning.patch
Patch99:        patches/storvsc_drv.c-20111206.patch
Patch100:       storvsc_drv.KBUILD_MODNAME.patch
Patch101:       storvsc_drv.MODULE_ALIAS.patch
Patch102:       storvsc_drv.hyperv.h.patch
Patch103:       storvsc_drv.storvsc_queuecommand.patch
Patch104:       blkvsc.dummy.patch
License:        GPL v2 only
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with_kmp}
%if %{with_drivers_in_kmp}
%suse_kernel_module_package um xen  -f kmp_filelist -p hyper-v.supplements.txt
%else
%suse_kernel_module_package um xen  -f kmp_filelist -p hyper-v.supplements.txt
%endif
%endif

%description
This package contains the Microsoft Hyper-V tools.



%if %{with_kmp}

%package KMP
Group:          System/Kernel
License:        GPL v2 only
Summary:        Microsoft Hyper-V drivers

%description KMP
This package contains the Microsoft Hyper-V drivers.



%endif

%prep
%setup -Tc -a 42
%patch42 -p0
%patch43 -p0
%patch99 -p1
%patch100 -p0
%patch101 -p0
%patch102 -p0
%patch103 -p1
%patch104 -p1
cp -vL %_sourcedir/hyper-v.dummy_ko.c hv

%build
hv=$PWD/hv
gcc $RPM_OPT_FLAGS -g %{S:10} -o %{hv_kvp_daemon}
%if %{with_kmp}
for flavor in %flavors_to_build; do
%if %{with_drivers_in_kmp}
    krel=$(make -s -C %{kernel_source $flavor} kernelrelease)
    cp -a ${hv} $flavor
%else
    rm -rfv $flavor
    mkdir -p $flavor
    cp %_sourcedir/hyper-v.dummy_ko.c $flavor/hyper-v.suse_kmp_dummy.c
    cat > $flavor/Makefile <<-EOF
obj-m += hyper-v.suse_kmp_dummy.o
EOF
%endif
    cp %_sourcedir/Module.supported $flavor
    make -C %{kernel_source $flavor} modules M=$PWD/$flavor
done
%endif

%install
%if %{with_kmp}
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
    make -C %{kernel_source $flavor} modules_install M=$PWD/$flavor
done
%endif
mkdir -p $RPM_BUILD_ROOT/usr/sbin
install -m755 %{hv_kvp_daemon} $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install -m755 %{S:11} $RPM_BUILD_ROOT/etc/init.d/%{hv_kvp_daemon}
ln -sfvbn ../../etc/init.d/%{hv_kvp_daemon} $RPM_BUILD_ROOT/usr/sbin/rc%{hv_kvp_daemon}
mkdir -p $RPM_BUILD_ROOT/etc/modprobe.d
install -m644 %SOURCE1 $RPM_BUILD_ROOT/etc/modprobe.d/hyperv_pvdrivers.conf
# Copy scripts to be used during postinstall
install -d -m0755 $RPM_BUILD_ROOT/opt/microsoft-hyper-v
install -m0755 $RPM_SOURCE_DIR/updateinitrd.pl $RPM_BUILD_ROOT/opt/microsoft-hyper-v/updateinitrd.pl
install -m0755 $RPM_SOURCE_DIR/update_UUID_in_grub.pl $RPM_BUILD_ROOT/opt/microsoft-hyper-v/update_UUID_in_grub.pl
install -m0755 $RPM_SOURCE_DIR/update_UUID_in_bootloader.pl $RPM_BUILD_ROOT/opt/microsoft-hyper-v/update_UUID_in_bootloader.pl
install -m0755 $RPM_SOURCE_DIR/updatefstab.sh $RPM_BUILD_ROOT/opt/microsoft-hyper-v/updatefstab.sh

%files
%defattr (-,root,root)
%if !%{with_kmp}
%dir /etc/modprobe.d
%config /etc/modprobe.d/hyperv_pvdrivers.conf
%endif
/etc/init.d/%{hv_kvp_daemon}
/usr/sbin/rc%{hv_kvp_daemon}
/usr/sbin/%{hv_kvp_daemon}
/opt/microsoft-hyper-v/

%post
dry_it() {

# exit cleanly so that local builds do not fail and taint the buildroot
	if $@
	then
		echo " succeeded."
	else
		echo " failed."
		exit 0
	fi
}
# Update initrd
# Note:  We must explicitly run mkinitrd because KMP post only runs mkinitrd
# when the modules being installed are in the existing initrd
echo "Updating initrd..."
dry_it /opt/microsoft-hyper-v/updateinitrd.pl %{HVMODULES} scsi_mod sd_mod sr_mod
# Write additional mods to INITRD_MODULES in order to cover subsequent initrd builds 
cp /etc/sysconfig/kernel /etc/sysconfig/kernel.backup
sed -e "s/^INITRD_MODULES=\"\(.*\)\"/INITRD_MODULES=\"\1 scsi_mod sd_mod sr_mod %{HVMODULES}\"/" /etc/sysconfig/kernel > /etc/sysconfig/kernel.tmp
mv /etc/sysconfig/kernel.tmp /etc/sysconfig/kernel
# Update grub
echo "Updating /boot/grub/menu.lst..."
dry_it /opt/microsoft-hyper-v/update_UUID_in_grub.pl
# Update /etc/sysconfig/bootloader
echo "Updating /etc/sysconfig/bootloader..."
dry_it /opt/microsoft-hyper-v/update_UUID_in_bootloader.pl
# Update fstab
echo "Updating /etc/fstab..."
dry_it /opt/microsoft-hyper-v/updatefstab.sh /etc/fstab -i

board_vendor=
product_name=
if pushd /sys/class/dmi/id > /dev/null 2>/dev/null
then
	if test -r board_vendor
	then
		board_vendor="`cat board_vendor`"
	fi
	if test -r product_name
	then
		product_name="`cat product_name`"
	fi
	popd > /dev/null
fi
if test "${board_vendor}" = "Microsoft Corporation" -a "${product_name}" = "Virtual Machine"
then
	echo "Enabling %{hv_kvp_daemon} on '${product_name}' from '${board_vendor}'"
	%{fillup_and_insserv -Y %{hv_kvp_daemon}}
else
	%{fillup_and_insserv %{hv_kvp_daemon}}
fi

%preun
%stop_on_removal %{hv_kvp_daemon}

%postun
%restart_on_update %{hv_kvp_daemon}
%insserv_cleanup
# Remove modules from INITRD_MODULES, kmp uninstall will take care of running mkinitrd
for i in %{HVMODULES}; do
  if grep " $i" /etc/sysconfig/kernel >/dev/null 2>&1; then
    if [ ! -f /etc/sysconfig/kernel.backup-hyper-v ]; then
      cp /etc/sysconfig/kernel /etc/sysconfig/kernel.backup-hyper-v
    fi
    sed -e "s/\(INITRD_MODULES.*\)$i\b\(.*\)/\1\2/" /etc/sysconfig/kernel > /etc/sysconfig/kernel.tmp
    mv /etc/sysconfig/kernel.tmp /etc/sysconfig/kernel
  fi
done

%changelog
* Fri Dec  9 2011 andavis@novell.com
- Update PLDP package:  1) update storvsc_drv.c to latest mainline
  code, 2) change hyperv_pvdrivers.conf to replace hv_blkvsc with
  hv_storvsc.
* Wed Oct 26 2011 andavis@suse.com
- Create PLDP package (bnc #726367)
  Add functionality to update initrd, grub, and fstab
